%
% 9)Run Dynare on the lq model file
% 10) Run this file


% Matrix_lagrange_basic_2c_cm_lq_out;

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% % HERE enter name of .mod file used to get LQ model if not the one run right now;
% if give fname_, the name will be the one of the last .mod file ran with
% dynare; If want to evaluate e.g. the companion model output of
% get_ramsey, run dynare on it and then give here the name of the original
% .mod file: e.g. original file is model.mod; output file is model_out.mod;
% run dynare model_out.mod and assign here to namemod the name 'model.mod';
% E.g. if running Nash solution, run model under Nash policies and then
% give here the name of the mod file produced with lq_1_get_mod for each
% policymaker;
namemod=['basic_2c_cm_optimal'];%fname_;%'three_country_oil4_real_gs_calib_lq';
ext_pol_prob='';
ser_lagr='basic_2c_cm_optimal_ts_lagr.mat';


eval(['load ',[namemod,'_variables.mat']]);
%%%%% OPTIONAL e.g. for non-cooperative solution
%% assgn switches e.g. if coop btw ea and us then uu_us_a=1=uu_ea_a; 
uu_us_a=1;
uu_ea_a=1;
uu_opec_a=0;

%% assign switches for evaluation of derivative of objective function only;
%% e.g. if despite coop want to know the welfare of the ea country
%% uu_us_a=0;uu_ea_a=1; 
uu_us_o=1;
uu_ea_o=0;
uu_opec_o=0;
%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%



lgy2_=lgy_(dr_.order_var,:); % variables as appear in the canonical VAR rapresentation
[xx,alpha_ord]=sort(dr_.order_var);
% generate reordering matrices to turn Dynare output into alphabetical
% order



% reorder the variables of Dynare ouput
% extract endogenous and endogenous positions

nstat=dr_.nstatic;
npred=dr_.nspred;


pos_n=[];
xx=[];
zz=1;
for jj=1:size(vary,1);
    xx=(find_incell(str2cell(lgy2_),['\<',deblank(vary{jj}),'\>']));
    if ~isempty(xx)
        pos_n(zz,1)=(xx);
        zz=zz+1;
    end
end
zz=1;
xx=[];
pos_x=[];

for jj=1:size(ex_var,1);
    xx=(find_incell(str2cell(lgy2_),['\<',deblank(ex_var{jj}),'\>']));
    
    if ~isempty(xx)
    
        pos_x(zz,1)=(xx);
        zz=zz+1;
    end
end
xx=[];
pos_lagr=[];
zz=1;
for jj=1:size(lagnam,1);
    xx=(find_incell(str2cell(lgy2_),['\<',deblank(lagnam{jj}),'\>']));
    
    if ~isempty(xx)
    
        pos_lagr(zz,1)=(xx);
        zz=zz+1;
    end
end
extr_n=eye(size(lgy_,1));
extr_n=extr_n(pos_n,:);
extr_x=eye(size(lgy_,1));
extr_x=extr_x(pos_x,:);
extr_lagr=eye(size(lgy_,1));
extr_lagr=extr_lagr(pos_lagr,:);
%%%%%
% to check correctness of variable extraction compare the following
% [lgy2_(extr_x*[1:size(lgy_,1)]',:),char(ex_var)]
% and
% [lgy2_(extr_n*[1:size(lgy_,1)]',:),char(vary)]


uu_us=uu_us_o;
uu_ea=uu_ea_o;
uu_opec=uu_opec_o;
eval(['Hut_',namemod])      
eval(['Hut_cs_',namemod]) 
uu_us=uu_us_a;
uu_ea=uu_ea_a;
uu_opec=uu_opec_a;


lq_get_ss_lagr;





% evaluation of BW x-derivative matrices

eval(['Hbt_',namemod])    
eval(['Hbt_cm1_',namemod])  
eval(['Hbt_cs_',namemod])   
eval(['Hbt_m1_',namemod])   
eval(['Hbt_m1s_',namemod])  
eval(['Hft_',namemod])      
eval(['Hft_cs_',namemod])   
eval(['Hft_p1_',namemod])   
eval(['Hft_p1c_',namemod])  
eval(['Hft_p1s_',namemod])  
% BW matrices (see after 2.18)
H_mx=Hbt+nbeta*Hbt_m1+Hft+1/nbeta*Hft_p1;

R_mx=Hbt_cm1+1/nbeta*Hft_p1c;
Z1_mx=nbeta*Hbt_m1s;
Z2_mx=Hbt_cs+Hft_cs;
Z3_mx=1/nbeta*Hft_p1s;

Q_mx=H_mx+Hut;
B2_mx=Z2_mx+Hut_cs;

if exist(ser_lagr,'file');
%     opt_lagr=dlmread(ser_lagr);

eval(['load  ',ser_lagr])
        disp('----------------------------------------------------');

    disp(('Optimal reference model in : dr_opt'));
    disp('----------------------------------------------------');
end
lq_eval_welfare_sub1;
savlag=input('Need to save state-space model (e.g. reference model)? (default is 0)[1/0] : ');
if savlag==1
if exist('dr_','var');

    dr_opt=dr_;
    dr_opt.extr_lagr=extr_lagr(1:szf,:);
    dr_opt.compen=compen;
    dr_opt.Welfare=Welfare;
%     dr_opt.extrmx=extrmx;
%     yy_=y_(dr_.order_var,:);
%     dlmwrite([fname_,'_ts_lagr.m'],yy_(pos_lagr,:) );
    eval(['save ', [fname_,'_ts_lagr.mat'],'  dr_opt -MAT'] );

    %eval(['save ',fname_,'_ts_lagr.mat y_(pos_lagr,:) -MAT']);
    disp(['Saved reference model in in ', fname_,'_ts_lagr.mat']);
end
end
disp('---------------  Welfare under the Current Policy ----------------------------------');
fprintf('Welfare is: %10.8f \n',double(Welfare))
fprintf('Commitment violation penalty is: %10.8f \n',double(compen));
fprintf('Total welfare is: %10.8f \n',double(compen)+double(Welfare));
disp('--------------------------------------------------------------------------------------');


if exist('dr_opt','var');
    if isfield(dr_opt,'Welfare')
        disp('---------------  Welfare under the Reference Policy ----------------------------------');
  fprintf('Welfare is: %10.8f \n',double(dr_opt.Welfare))
fprintf('Commitment penalty is: %10.8f \n',double(dr_opt.compen));
fprintf('Total welfare is: %10.8f \n',double(dr_opt.compen)+double(dr_opt.Welfare));  
disp('--------------------------------------------------------------------------------------');
loss=double(dr_opt.compen)+double(dr_opt.Welfare)-(double(compen)+double(Welfare));
fprintf('Welfare loss is (loss): %10.8f \n',loss);  
disp('--------------------------------------------------------------------------------------');
    end
end

%%% for symbolic evaluation run the following
if 0
    lq_symbol_welf;
    
end
