%
% 9)Run Dynare on the lq model file
% 10) Run this file


% Matrix_lagrange_basic_2c_cm_lq_out;

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% % HERE enter name of .mod file used to get LQ model if not the one run right now;
% if give fname_, the name will be the one of the last .mod file ran with
% dynare; If want to evaluate e.g. the companion model output of
% get_ramsey, run dynare on it and then give here the name of the original
% .mod file: e.g. original file is model.mod; output file is model_out.mod;
% run dynare model_out.mod and assign here to namemod the name 'model.mod';
% E.g. if running Nash solution, run model under Nash policies and then
% give here the name of the mod file produced with lq_1_get_mod for each
% policymaker;

% clear all;


namemod='three_country_oil4_real_gs_calib_lq';
ext_pol_prob='_coop';
eval(['load ',[namemod,'_variables.mat']]);

%%%%% OPTIONAL e.g. for non-cooperative solution
%% assgn switches
%% assgn switches e.g. if coop btw ea and us then uu_us_a=1=uu_ea_a; 


%% assign switches for evaluation of derivative of objective function only;
%% e.g. if despite coop want to know the welfare of the ea country
%% uu_us_a=0;uu_ea_a=1; 


%%%%%%%%%%%%%%%%%%%%%%%%%%%%


eval(['load matrices_',namemod]);
eval(['ys=',namemod,'_steadystate(0);']);
ys=ys(:);
lgy2_=matrices.varyt;
[kk,jj]=sortrows(lower(lgy2_));
tmp=lgy2_(jj,:);


for jj=1:size(tmp,1);
        eval([deblank(tmp(jj,:)),'_ss=',num2str(ys(jj),16),';']);

    eval([tmp(jj,:),'=',num2str(ys(jj),16),';']);
end
nsh=size(matrices.shocky,1);
shocky=lgy2_(1:nsh,:);
eval([namemod,'_M']);
neq=size(matrices.A_0,1);
% keyboard
sortinnov=matrices.sortinnov;
eval([namemod,'_A']);
M_mx=[Msh(:,matrices.sortinnov);zeros(size(AA,1)-matrices.jumping,nsh)];

innovations=matrices.shocky;

mxpl=matrices.mxpl;
%%% this assumes that shocks are std_inno and innovations are named e_inno;
Sigma=[];
         for jj=1:nsh
             eval(['Sigma=[Sigma;std_',innovations(jj,3:end),'];']);
         end
         
Sigma=diag(Sigma.^2);         


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
lgy2_=lgy2_(end:-1:1,:);

pos_n=[];
zz=1;
for jj=1:size(vary,1);
    xx=(find_incell(str2cell(lgy2_),['\<',deblank(vary{jj}),'\>']));
    if ~isempty(xx)
        pos_n(zz,1)=(xx);
        zz=zz+1;
    end
end
zz=1;
pos_x=[];
for jj=1:size(ex_var,1);
    xx=(find_incell(str2cell(lgy2_),['\<',deblank(ex_var{jj}),'\>']));
    
    if ~isempty(xx)
    
        pos_x(zz,1)=(xx);
        zz=zz+1;
    end
end
extr_n=eye(size(lgy2_,1));
extr_n=extr_n(pos_n,:);
extr_x=eye(size(lgy2_,1));
extr_x=extr_x(pos_x,:);

%%%%%
% to check correctness of variable extraction compare the following
% [lgy2_(extr_x*[1:size(lgy_,1)]',:),char(ex_var)]
% and
% [lgy2_(extr_n*[1:size(lgy_,1)]',:),char(vary)]




lq_get_ss_lagr;



% evaluation of BW x-derivative matrices

eval(['Hbt_',namemod])    
eval(['Hbt_cm1_',namemod])  
eval(['Hbt_cs_',namemod])   
eval(['Hbt_m1_',namemod])   
eval(['Hbt_m1s_',namemod])  
eval(['Hft_',namemod])      
eval(['Hft_cs_',namemod])   
eval(['Hft_p1_',namemod])   
eval(['Hft_p1c_',namemod])  
eval(['Hft_p1s_',namemod])  



% BW matrices (see after 2.18)
H_mx=Hbt+nbeta*Hbt_m1+Hft+1/nbeta*Hft_p1;

R_mx=Hbt_cm1+1/nbeta*Hft_p1c;
Z1_mx=nbeta*Hbt_m1s;
Z2_mx=Hbt_cs+Hft_cs;
Z3_mx=1/nbeta*Hft_p1s;


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%% LOOOOOOOPS

if 0

range_val_1=1.683;[1.1:.5:5.5];
range_val_2=1.683;[1.1:.5:5.5];
range_val_3=0;[-1:.1:1];
range_val_4=0;[-1:.1:1];
sz_rv1=length(range_val_1);
sz_rv2=length(range_val_2);
sz_rv3=length(range_val_3);
sz_rv4=length(range_val_4);
param_loop=zeros(4,1);




z_count=0;
k_count=1;
z_count=1;
Welf_h=zeros(sz_rv4,sz_rv3,sz_rv2,sz_rv1);
Welf_f=zeros(sz_rv4,sz_rv3,sz_rv2,sz_rv1);
flags=zeros(sz_rv4,sz_rv3,sz_rv2,sz_rv1);


%tic

for j_count=1:sz_rv1
param_loop(1)=range_val_1(j_count);%lambda_pii_n_s

for i_count=1:sz_rv2;
param_loop(2)=range_val_2(i_count);%lambda_pii_n

for z_count=1:sz_rv3
param_loop(3)=range_val_3(z_count);%lambda_pii_n_s

for k_count=1:sz_rv4;
param_loop(4)=range_val_4(k_count);%lambda_pii_n

lambda_pii_n=param_loop(1);
lambda_pii_n_s=param_loop(2);
lambda_pe=param_loop(3)/param_loop(1);
lambda_pe_s=param_loop(4)/param_loop(2);


uu_us=0;
uu_ea=1;
uu_opec=0;


lq_loopable_symb;


Welf_h(k_count,z_count,i_count,j_count)=Welfare;


uu_us=1;
uu_ea=0;
uu_opec=0;
lq_loopable_symb;
Welf_f(k_count,z_count,i_count,j_count)=Welfare;
% else
% Welf_h(k_count,z_count,i_count,j_count)=NaN;
% 
% Welf_f(k_count,z_count,i_count,j_count)=NaN;
% end

end
end
end
end
toc
end








%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

fprintf('Welfare is: %10.8f \n',double(Welfare))

%%% for symbolic evaluation run the following
if 0
    lq_symbol_welf;
    
end
