

%     %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%     % set symbolic parameters that you want to have explicitly in the
%     solution
%     In order to make the following work the matrices should have been
%     initialized to symbolic (this could be done in the lq_1_get_mod by
%     giving 1 to symbolic option
%     %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
if ~exist('namemod','var')
    error('you must first run dynare on the optimal model, then lq_eval_welfare and finally this file');
end
if 0
    syms subsidy theta bet vsig Y pii pii_obj phi shock_prod m1 m2 pii_ss Y_ss
    syms rho_y   rho_pii   rho_r  std_prod  std_pref  std_policy  h  gam  alph  vsig  C_ss  cobwel  nbeta;
    Y=log(((theta-1)/theta)^(1/(1+vsig))); %
    pii=log(pii_obj);
    Psh=1;
    ramsey1=m1;
    ramsey2=m2;
    shock_prod=1;
    
    eval(['Hut_',namemod])
    eval(['Hut_cs_',namemod])
    eval(['Hbt_',namemod])
    eval(['Hbt_cm1_',namemod])
    eval(['Hbt_cs_',namemod])
    eval(['Hbt_m1_',namemod])
    eval(['Hbt_m1s_',namemod])
    eval(['Hft_',namemod])
    eval(['Hft_cs_',namemod])
    eval(['Hft_p1_',namemod])
    eval(['Hft_p1c_',namemod])
    eval(['Hft_p1s_',namemod])
    H_mx=Hbt+nbeta*Hbt_m1+Hft+1/nbeta*Hft_p1;
    
    R_mx=Hbt_cm1+1/nbeta*Hft_p1c;
    Z1_mx=nbeta*Hbt_m1s;
    Z2_mx=Hbt_cs+Hft_cs;
    Z3_mx=1/nbeta*Hft_p1s;
    
    Q_mx=H_mx+Hut;
    B2_mx=Z2_mx+Hut_cs;
end


sym_v=[];
% for jj=1:size(lagrlst,1);eval(['syms ',lagrlst{jj},';']);end
sym_v_m1=[];
sym_v_p1=[];
for jj=1:size(vary,1)
    sym_v=[sym_v;sym(vary{jj})];
    sym_v_m1=[sym_v_m1;sym([vary{jj},'_m1'])];
    sym_v_p1=[sym_v_p1;sym([vary{jj},'_p1'])];
    eval(['syms ',char(sym_v(jj)),' ',char(sym_v_m1(jj)),' ',char(sym_v_p1(jj))]);
end
sym_x=[];
sym_x_m1=[];
sym_x_p1=[];
for jj=1:size(ex_var,1)
    sym_x=[sym_x;sym(ex_var{jj})];
    sym_x_m1=[sym_x_m1;sym([ex_var{jj},'_m1'])];
    sym_x_p1=[sym_x_p1;sym([ex_var{jj},'_p1'])];
    eval(['syms ',char(sym_x(jj)),' ',char(sym_x_m1(jj)),' ',char(sym_x_p1(jj))]);
end


% g1=sym_v.'*Hft*sym_v;
% g2=sym_v_p1.'*Hft_p1c*sym_v;
% g3=sym_v_p1.'*Hft_p1*sym_v_p1;
% g4=sym_v_p1.'*Hft_p1s*sym_x;
% g5=sym_v.'*Hft_cs*sym_x;
% 
% 
% f1=sym_v.'*Hbt*sym_v;
% f2=sym_v.'*Hbt_cm1*sym_v_m1;
% f3=sym_v_m1.'*Hbt_m1*sym_v_m1;
% f4=sym_v_m1.'*Hbt_m1s*sym_x;
% f5=sym_v.'*Hbt_cs*sym_x;
% 
% u1=sym_v.'*Hut*sym_v;
% u2=sym_v.'*Hut_cs*sym_x;
% sym_v2=extr_n*sym_v;

Welfare_s=(1/2*(sym_v.'*(Q_mx)*sym_v+2*sym_v.'*(R_mx)*sym_v_m1+...
    2*(sym_v_m1.'*(Z1_mx)*sym_x+sym_v.'*(B2_mx)*sym_x+sym_v.'*(Z3_mx)*sym_x_m1)));
tmp=simplify(Welfare_s);
disp('Quadratic welfare function (tmp variable): NB this might have several close to zero coeffs')
disp(vpa(tmp,3));


% if 0



reduce=input('Eliminate zero coeffs?(1/0) ');
if reduce % all the following could be too much for a large model
    allsim=[[sym_v;sym_x].',[sym_v_m1;sym_x_m1].',[sym_v_p1;sym_x_p1].'];
    
    % kk=round(double(maple('hessian',Welfare_s,cell2str(sym2cell(allsim),0)))*9)/9;
    kk=round(double(hessian_s(tmp,allsim.'))*1e11)/(1e11);
    % notation
    
    % pure_vars=allsim;
    %
    % list_dif=cell(length(allsim),1);
    % for jj=1:length(allsim);
    %     timed_vars=(regexprep(char(allsim(jj)),'\_m1','(-1)'));
    % timed_vars=(regexprep(timed_vars,'\_p1','(+1)'));
    %
    % vtmp=(regexprep(char(allsim(jj)),'\_m1',''));
    % vtmp=(regexprep(vtmp,'\_p1',''));
    % list_dif{jj,1}=['(',char(timed_vars),'-',vtmp,'_ss)'];
    % end
    %
    
    % tmp_variab=regexprep(cell2str(str2cell(lgy2_),0),'\[|\]','');
    % tmp_variab=['{',tmp_variab,'}'];
    heswelf=kk;%subs(kk,allsim,0);
    % simv=eval(cell2str(str2cell(lgy2_),0)).';
    vcvstr=vech2(allsim.'*allsim);
    gg=diag(repmat(0.5,length(allsim),1));
    uu=ones(length(allsim))-gg;
    ff=vech2(uu).*vcvstr;
    new_Welf=char(simplify(vech2(heswelf).'*ff));
    Welf4simul=new_Welf;
    Welf4simul=regexprep(Welf4simul,'\*','''*');
     ss_vars=[];
     ss_vars_eq=[];
    for jj=1:length(sym_v);
        new_Welf=regexprep(new_Welf,['(?<=[\s*\*\)\(+-])',char(sym_v(jj)),'(?=[\s*+-\^\*\)\(])'],['(',char(sym_v(jj)),'-',char(sym_v(jj)),'_ss)']);
 new_Welf=regexprep(new_Welf,['(?<=[\s*+-\*\)\(])',char(sym_v(jj)),'\_m1(?=[\s*+-\^\*\)\(])'],['(',char(sym_v(jj)),'(-1)-',char(sym_v(jj)),'_ss)']);
  new_Welf=regexprep(new_Welf,['(?<=[\s*+-\*\)\(])',char(sym_v(jj)),'\_p1(?=[\s*+-\^\*\)\(])'],['(',char(sym_v(jj)),'(+1)-',char(sym_v(jj)),'_ss)']);
  ss_vars{jj,1}=[char(sym_v(jj)),'_ss,'];
  ss_vars_eq{jj,1}=[char(sym_v(jj)),'_ss','=',char(sym_v(jj)),';'];
Welf4simul=regexprep(Welf4simul,['(?<t>',char(sym_v(jj)),')\^2'],['$<t>''*',char(sym_v(jj))]);

    end

%    new_Welf=(regexprep(new_Welf,'\_m1','(-1)'));
%     new_Welf=(regexprep(new_Welf,'\_p1','(+1)'));
    
    disp('Quadratic Welfare for Dynare saved in in new_Welf_expr.m; also in variable new_Welf');
    disp('Quadratic Welfare for simultaion saved in in Welf4simul.m; also in variable Welf4simul');
    disp(new_Welf)
    disp('These vectors can be copied in the mod file (among parameters) and in the steady state file')
    char(ss_vars)
    char(ss_vars_eq)
    fid=fopen('new_Welf_expr.m','w+');
    fod=fopen('Welf4simul.m','w+');
    fprintf(fid,'%s',['LQ_welfare=',new_Welf,';']);
    fprintf(fod,'%s',['LQ_welfare=',Welf4simul,';']);
    fclose(fid);
    fclose(fod);
    [xx,gg]=coeffs(tmp);
    lst=[];
    for jj=1:length(gg);
        lst{jj,1}=char(gg(jj));
    end
    lst2=regexprep(lst,'dummy\_lq\_','');
    lst2=regexprep(lst2,'\_p1|\_m1','');
    lst2=unique(lst2);
    disp('The list of variables entering the reduced welfare function are in lst2');
end
